Index: cpukit/libfs/src/dosfs/msdos_misc.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_misc.c,v
retrieving revision 1.14
diff -p -u -u -r1.14 msdos_misc.c
--- cpukit/libfs/src/dosfs/msdos_misc.c	4 Sep 2008 08:33:06 -0000	1.14
+++ cpukit/libfs/src/dosfs/msdos_misc.c	23 Apr 2009 07:54:40 -0000
@@ -764,111 +989,621 @@ msdos_dir_is_empty(
  *     appropriately)
  *
  */
+#define MSDOS_FIND_PRINT 0
 int msdos_find_name_in_fat_file(
     rtems_filesystem_mount_table_entry_t *mt_entry,
     fat_file_fd_t                        *fat_fd,
-    char                                 *name,
-    fat_auxiliary_t                      *paux,
+    bool                                  create_node,
+    const char                           *name,
+    int                                   name_len,
+    msdos_name_type_t                     name_type,
+    fat_dir_pos_t                        *dir_pos,
     char                                 *name_dir_entry
-    )
+                                )
 {
-    int              rc = RC_OK;
     ssize_t          ret = 0;
     msdos_fs_info_t *fs_info = mt_entry->fs_info;
-    uint32_t         i = 0, j = 0;
+    uint32_t         dir_offset = 0;
+    uint32_t         dir_entry = 0;
     uint32_t         bts2rd = 0;
+    fat_pos_t        lfn_start;
+    bool             lfn_matched = false;
+    uint8_t          lfn_checksum = 0;
+    int              lfn_entries = 0;
+    int              lfn_entry = 0;
+    uint32_t         empty_space_offset = 0;
+    uint32_t         empty_space_entry = 0;
+    uint32_t         empty_space_count = 0;
+    bool             empty_space_found = false;
+    uint32_t         entries_per_block;
+    bool             read_cluster = false;
+
+    assert(name_len > 0);
+
+    fat_dir_pos_init(dir_pos);
+    
+    lfn_start.cln = lfn_start.ofs = FAT_FILE_SHORT_NAME;
+    
+    /*
+     * If the file name is long how many short directory
+     * entries are needed ?
+     */
+    if (name_type == MSDOS_NAME_LONG)
+    {
+        lfn_entries = ((name_len - 1) + MSDOS_LFN_LEN_PER_ENTRY) / MSDOS_LFN_LEN_PER_ENTRY;
 
+        /*
+         * If we are creating a long file name node create a random short
+         * entry for the long file name. Ignore the MSDOS version as that
+         * requires too much processing to find and handle the next number.
+         */
+        if (create_node)
+            msdos_short_random_name(MSDOS_DIR_NAME(name_dir_entry));
+    }
+            
     if (FAT_FD_OF_ROOT_DIR(fat_fd) &&
-       (fs_info->fat.vol.type & (FAT_FAT12 | FAT_FAT16)))
+        (fs_info->fat.vol.type & (FAT_FAT12 | FAT_FAT16)))
         bts2rd = fat_fd->fat_file_size;
     else
         bts2rd = fs_info->fat.vol.bpc;
 
-    while ((ret = fat_file_read(mt_entry, fat_fd, (j * bts2rd), bts2rd,
-                                fs_info->cl_buf)) != FAT_EOF)
+    entries_per_block = bts2rd / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE;
+
+#if MSDOS_FIND_PRINT
+    printf ("MSFS:[1] cn:%i ebp:%li bts2rd:%li lfne:%d nl:%i n:%s\n",
+            create_node, entries_per_block, bts2rd, lfn_entries, name_len, name);
+#endif
+    /*
+     * Scan the directory seeing if the file is present. While
+     * doing this see if a suitable location can be found to
+     * create the entry if the name is not found.
+     */
+    while ((ret = fat_file_read(mt_entry, fat_fd, (dir_offset * bts2rd),
+                                bts2rd, fs_info->cl_buf)) != FAT_EOF)
     {
+        bool remainder_empty = false;
+#if MSDOS_FIND_PRINT
+        printf ("MSFS:[2] dir_offset:%li\n", dir_offset);
+#endif
+        
         if (ret < MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
             rtems_set_errno_and_return_minus_one(EIO);
 
         assert(ret == bts2rd);
 
         /* have to look at the DIR_NAME as "raw" 8-bit data */
-        for (i = 0; i < bts2rd; i += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
+        for (dir_entry = 0;
+             dir_entry < bts2rd;
+             dir_entry += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
         {
-            /* is the entry empty ? */
-            if (((*(uint8_t *)MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
-                 MSDOS_THIS_DIR_ENTRY_AND_REST_EMPTY) ||
-                 ((*(uint8_t *)MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
-                 MSDOS_THIS_DIR_ENTRY_EMPTY))
-            {
-                /* whether we are looking for an empty entry */
-                if (name == NULL)
-                {
-                    /* get current cluster number */
-                    rc = fat_file_ioctl(mt_entry, fat_fd, F_CLU_NUM,
-                                        j * bts2rd, &paux->cln);
-                    if (rc != RC_OK)
-                        return rc;
-
-                    /* offset is computed in bytes */
-                    paux->ofs = i;
+            char* entry = (char*) fs_info->cl_buf + dir_entry;
 
-                    /* write new node entry */
-                    ret = fat_file_write(mt_entry, fat_fd, j * bts2rd + i,
-                                         MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE,
-                                         (uint8_t *)name_dir_entry);
-                    if (ret != MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
-                        return -1;
-
-                    /*
-                     * we don't update fat_file_size here - it should not
-                     * increase
-                     */
-                    return RC_OK;
-                }
+            /*
+             * See if the entry is empty or the remainder of the directory is
+             * empty ? Localise to make the code read better.
+             */
+            bool entry_empty = (*MSDOS_DIR_ENTRY_TYPE(entry) ==
+                                MSDOS_THIS_DIR_ENTRY_EMPTY);
+            remainder_empty = (*MSDOS_DIR_ENTRY_TYPE(entry) ==
+                               MSDOS_THIS_DIR_ENTRY_AND_REST_EMPTY);
+#if MSDOS_FIND_PRINT
+            printf ("MSFS:[3] re:%i ee:%i do:%li de:%li(%ld)\n",
+                    remainder_empty, entry_empty, dir_offset,
+                    dir_entry, (dir_entry / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE));
+#endif
+            /*
+             * Remember where the we are, ie the start, so we can come back
+             * to here and write the long file name if this is the start of
+             * a series of empty entries. If empty_space_count is 0 then
+             * we are currently not inside an empty series of entries. It
+             * is a count of empty entries.
+             */
+            if (empty_space_count == 0)
+            {
+                empty_space_entry = dir_entry;
+                empty_space_offset = dir_offset;
+            }
 
+            if (remainder_empty)
+            {
+#if MSDOS_FIND_PRINT
+                printf ("MSFS:[3.1] cn:%i esf:%i\n", create_node, empty_space_found);
+#endif
                 /*
-                 * if name != NULL and there is no more entries in the
+                 * If just looking and there is no more entries in the
                  * directory - return name-not-found
                  */
-                if (((*MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
-                     MSDOS_THIS_DIR_ENTRY_AND_REST_EMPTY))
+                if (!create_node)
                     return MSDOS_NAME_NOT_FOUND_ERR;
+
+                /*
+                 * Lets go and write the directory entries. If we have not found
+                 * any available space add the remaining number of entries to any that
+                 * we may have already found that are just before this entry. If more
+                 * are needed FAT_EOF is returned by the read and we extend the file.
+                 */
+                if (!empty_space_found)
+                {
+                  empty_space_count +=
+                    entries_per_block - (dir_entry / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
+                  empty_space_found = true;
+#if MSDOS_FIND_PRINT
+                  printf ("MSFS:[3.2] esf:%i esc%i\n", empty_space_found, empty_space_count);
+#endif
+                }
+                break;
+            }
+            else if (entry_empty)
+            {
+                if (create_node)
+                {
+                  /*
+                   * Remainder is not empty so is this entry empty ?
+                   */
+                  empty_space_count++;
+                
+                  if (empty_space_count == (lfn_entries + 1))
+                    empty_space_found = true;
+                }
+#if MSDOS_FIND_PRINT
+                printf ("MSFS:[4.1] esc:%li esf:%i\n",
+                        empty_space_count, empty_space_found);
+#endif
             }
             else
             {
-                /* entry not empty and name != NULL -> compare names */
-                if (name != NULL)
+                /*
+                 * A valid entry so handle it.
+                 *
+                 * If empty space has not been found we need to start the
+                 * count again.
+                 */
+                if (create_node && !empty_space_found)
                 {
-                    if (strncmp(MSDOS_DIR_NAME((fs_info->cl_buf + i)), name,
-                                MSDOS_SHORT_NAME_LEN) == 0)
+                    empty_space_entry = 0;
+                    empty_space_count = 0;
+                }
+
+                /*
+                 * Check the attribute to see if the entry is for a long
+                 * file name.
+                 */
+                if ((*MSDOS_DIR_ATTR(entry) & MSDOS_ATTR_LFN_MASK) ==
+                    MSDOS_ATTR_LFN)
+                {
+                    char* p;
+                    int   o;
+                    int   i;
+#if MSDOS_FIND_PRINT
+                    printf ("MSFS:[4.2] lfn:%c entry:%i checksum:%i\n",
+                            lfn_start.cln == FAT_FILE_SHORT_NAME ? 't' : 'f',
+                            *MSDOS_DIR_ENTRY_TYPE(entry) & MSDOS_LAST_LONG_ENTRY_MASK,
+                            *MSDOS_DIR_LFN_CHECKSUM(entry));
+#endif
+                    /*
+                     * If we are not already processing a LFN see if this is
+                     * the first entry of a LFN ?
+                     */
+                    if (lfn_start.cln == FAT_FILE_SHORT_NAME)
                     {
+                        lfn_matched = false;
+
                         /*
-                         * we get the entry we looked for - fill auxiliary
-                         * structure and copy all 32 bytes of the entry
+                         * The first entry must have the last long entry
+                         * flag set.
                          */
-                        rc = fat_file_ioctl(mt_entry, fat_fd, F_CLU_NUM,
-                                            j * bts2rd, &paux->cln);
+                        if ((*MSDOS_DIR_ENTRY_TYPE(entry) &
+                             MSDOS_LAST_LONG_ENTRY) == 0)
+                            continue;
+
+                        /*
+                         * Does the number of entries in the LFN directory
+                         * entry match the number we expect for this
+                         * file name.
+                         */
+                        if (lfn_entries != (*MSDOS_DIR_ENTRY_TYPE(entry) &
+                                            MSDOS_LAST_LONG_ENTRY_MASK))
+                            continue;
+                        
+                        /*
+                         * Get the checksum of the short entry.
+                         */
+                        lfn_start.cln = dir_offset;
+                        lfn_start.ofs = dir_entry;
+                        lfn_entry = lfn_entries;
+                        lfn_checksum = *MSDOS_DIR_LFN_CHECKSUM(entry);
+                        
+#if MSDOS_FIND_PRINT
+                        printf ("MSFS:[4.3] lfn_checksum:%i\n",
+                                *MSDOS_DIR_LFN_CHECKSUM(entry));
+#endif
+                    }
+
+                    /*
+                     * If the entry number or the check sum do not match
+                     * forget this series of long directory entries. These
+                     * could be orphaned entries depending on the history
+                     * of the disk.
+                     */
+                    if ((lfn_entry != (*MSDOS_DIR_ENTRY_TYPE(entry) &
+                                       MSDOS_LAST_LONG_ENTRY_MASK)) ||
+                        (lfn_checksum != *MSDOS_DIR_LFN_CHECKSUM(entry)))
+                    {
+#if MSDOS_FIND_PRINT
+                        printf ("MSFS:[4.4] no match\n");
+#endif
+                        lfn_start.cln = FAT_FILE_SHORT_NAME;
+                        continue;
+                    }
+
+                    lfn_entry--;
+                    o = lfn_entry * MSDOS_LFN_LEN_PER_ENTRY;
+                    p = entry + 1;
+                        
+#if MSDOS_FIND_PRINT
+                    printf ("MSFS:[5] lfne:%i\n", lfn_entry);
+#endif
+                    for (i = 0; i < MSDOS_LFN_LEN_PER_ENTRY; i++)
+                    {
+#if MSDOS_FIND_PRINT > 1
+                        printf ("MSFS:[6] o:%i i:%i *p:%c(%02x) name[o + i]:%c(%02x)\n",
+                                o, i, *p, *p, name[o + i], name[o + i]);
+#endif
+                        if (*p == '\0')
+                            break;
+                        
+                        if (((o + i) >= name_len) || (*p != name[o + i]))
+                        {
+                            lfn_start.cln = FAT_FILE_SHORT_NAME;
+#if MSDOS_FIND_PRINT
+                            printf ("MSFS:[8] lfn:%c\n",
+                                    lfn_start.cln == FAT_FILE_SHORT_NAME ? 't' : 'f');
+#endif
+                            break;
+                        }
+
+                        switch (i)
+                        {
+                            case 4:
+                                p += 5;
+                                break;
+                            case 10:
+                                p += 4;
+                                break;
+                            default:
+                                p += 2;
+                                break;
+                        }
+                    }
+
+                    lfn_matched = ((lfn_entry == 0) &&
+                                   (lfn_start.cln != FAT_FILE_SHORT_NAME));
+                    
+#if MSDOS_FIND_PRINT
+                    printf ("MSFS:[8.1] lfn_matched:%i\n", lfn_matched);
+#endif
+                }
+                else
+                {
+                    /*
+                     * SFN entry found.
+                     *
+                     * If a LFN has been found and it matched check the
+                     * entries have all been found and the checksum is
+                     * correct. If this is the case return the short file
+                     * name entry.
+                     */
+                    if (lfn_matched)
+                    {
+                        uint8_t  cs = 0;
+                        uint8_t* p = (uint8_t*) MSDOS_DIR_NAME(entry);
+                        int      i;
+
+                        for (i = 0; i < MSDOS_SHORT_NAME_LEN; i++, p++)
+                            cs = ((cs & 1) ? 0x80 : 0) + (cs >> 1) + *p;
+
+                        if (lfn_entry || (lfn_checksum != cs))
+                            lfn_matched = false;
+                    }
+#if 0
+                    /*
+                     * If we are creating a node and so have generated a
+                     * random SFN we need to make sure it is not alreay
+                     * present in the directory.
+                     */
+                    if (!lfn_matched &&
+                        create_node &&
+                        (name_type == MSDOS_NAME_LONG) &&
+                        (memcmp(MSDOS_DIR_NAME(entry),
+                                MSDOS_DIR_NAME(name_dir_entry),
+                                MSDOS_SHORT_NAME_LEN) == 0))
+                    {
+                        /*
+                         * FIXME: This should cause a rescan of all entries.
+                         */
+                        msdos_short_random_name(MSDOS_DIR_NAME(name_dir_entry));
+                    }
+#endif
+                    if (lfn_matched ||
+                        (memcmp(MSDOS_DIR_NAME(entry),
+                                MSDOS_DIR_NAME(name_dir_entry),
+                                MSDOS_SHORT_NAME_LEN) == 0))
+                    {
+                        /*
+                         * We get the entry we looked for - fill the position
+                         * structure and the 32 bytes of the short entry
+                         */
+                        int rc = fat_file_ioctl(mt_entry, fat_fd, F_CLU_NUM,
+                                                dir_offset * bts2rd,
+                                                &dir_pos->sname.cln);
                         if (rc != RC_OK)
                             return rc;
 
-                        /* offset is computed in bytes */
-                        paux->ofs = i;
-                        memcpy(name_dir_entry,(fs_info->cl_buf + i),
+                        dir_pos->sname.ofs = dir_entry;
+                        
+                        if (lfn_start.cln != FAT_FILE_SHORT_NAME)
+                        {
+                          rc = fat_file_ioctl(mt_entry, fat_fd, F_CLU_NUM,
+                                              lfn_start.cln * bts2rd,
+                                              &lfn_start.cln);
+                          if (rc != RC_OK)
+                            return rc;
+                        }
+                
+                        dir_pos->lname.cln = lfn_start.cln;
+                        dir_pos->lname.ofs = lfn_start.ofs;
+
+                        memcpy(name_dir_entry, entry,
                                MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
                         return RC_OK;
                     }
+                    
+                    lfn_start.cln = FAT_FILE_SHORT_NAME;
+                    lfn_matched = false;
                 }
             }
         }
-        j++;
+
+        if (remainder_empty)
+            break;
+
+        dir_offset++;
     }
-    return MSDOS_NAME_NOT_FOUND_ERR;
+
+    /*
+     * If we are not to create the entry return a not found error.
+     */
+    if (!create_node)
+      return MSDOS_NAME_NOT_FOUND_ERR;
+
+#if MSDOS_FIND_PRINT
+    printf ("MSFS:[8.1] WRITE do:%ld esc:%ld eso:%ld ese:%ld\n",
+            dir_offset, empty_space_count, empty_space_offset, empty_space_entry);
+#endif
+
+    /*
+     * If a long file name calculate the checksum of the short file name
+     * data to place in each long file name entry. First set the short
+     * file name to the slot of the SFN entry. This will mean no clashes
+     * in this directory.
+     */
+    lfn_checksum = 0;
+    if (name_type == MSDOS_NAME_LONG)
+    {
+        uint8_t* p = (uint8_t*) MSDOS_DIR_NAME(name_dir_entry);
+        int      i;
+        int      slot = (((empty_space_offset * bts2rd) + empty_space_entry) /
+                         MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE) + lfn_entries + 1;
+                  
+        msdos_short_name_hex(MSDOS_DIR_NAME(name_dir_entry), slot);
+
+        for (i = 0; i < 11; i++, p++)
+            lfn_checksum =
+                ((lfn_checksum & 1) ? 0x80 : 0) + (lfn_checksum >> 1) + *p;
+    }
+
+    /*
+     * If there is no space available then extend the file. The
+     * empty_space_count is a count of empty entries in the currently
+     * read cluster so if 0 there is no space. Note, dir_offset will
+     * be at the next cluster so we can just make empty_space_offset
+     * that value.
+     */
+    if (empty_space_count == 0)
+    {
+        read_cluster = true;
+        empty_space_offset = dir_offset;
+        empty_space_entry = 0;
+    }
+
+    /*
+     * Have we read past the empty block ? If so go back and read it again.
+     */
+    if (dir_offset != empty_space_offset)
+        read_cluster = true;
+
+    /*
+     * Handle the entry writes.
+     */
+    lfn_start.cln = lfn_start.ofs = FAT_FILE_SHORT_NAME;
+    lfn_entry = 0;
+
+#if MSDOS_FIND_PRINT
+    printf ("MSFS:[9] read_cluster:%d eso:%ld ese:%ld\n",
+            read_cluster, empty_space_offset, empty_space_entry);
+#endif
+
+    /*
+     * The one more is the short entry.
+     */
+    while (lfn_entry < (lfn_entries + 1))
+    {
+        int length = 0;
+        
+        if (read_cluster)
+        {
+          uint32_t new_length;
+#if MSDOS_FIND_PRINT
+          printf ("MSFS:[9.1] eso:%li\n", empty_space_offset);
+#endif
+          ret = fat_file_read(mt_entry, fat_fd,
+                              (empty_space_offset * bts2rd), bts2rd,
+                              fs_info->cl_buf);
+
+          if (ret != bts2rd)
+          {
+            if (ret != FAT_EOF)
+              rtems_set_errno_and_return_minus_one(EIO);
+
+#if MSDOS_FIND_PRINT
+            printf ("MSFS:[9.2] extending file:%li\n", empty_space_offset);
+#endif
+            ret = fat_file_extend (mt_entry, fat_fd, empty_space_offset * bts2rd,
+                                   &new_length);
+                                           
+            if (ret != RC_OK)
+              return ret;
+
+#if MSDOS_FIND_PRINT
+            printf ("MSFS:[9.3] extended: %d <-> %d\n", new_length, empty_space_offset * bts2rd);
+#endif
+            if (new_length != (empty_space_offset * bts2rd))
+              rtems_set_errno_and_return_minus_one(EIO);
+
+            memset(fs_info->cl_buf, 0, bts2rd);
+
+            ret = fat_file_write(mt_entry, fat_fd,
+                                 empty_space_offset * bts2rd,
+                                 bts2rd, fs_info->cl_buf);
+#if MSDOS_FIND_PRINT
+            printf ("MSFS:[9.4] clear write: %d\n", ret);
+#endif
+            if (ret != bts2rd)
+              rtems_set_errno_and_return_minus_one(EIO);
+          }
+        }
+        
+#if MSDOS_FIND_PRINT
+        printf ("MSFS:[10] eso:%li\n", empty_space_offset);
+#endif
+        
+        for (dir_entry = empty_space_entry;
+             dir_entry < bts2rd;
+             dir_entry += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
+        {
+            char*       entry = (char*) fs_info->cl_buf + dir_entry;
+            char*       p;
+            const char* n;
+            int         i;
+
+            length += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE;
+            lfn_entry++;
+            
+#if MSDOS_FIND_PRINT
+            printf ("MSFS:[10] de:%li(%li) length:%i lfn_entry:%i\n",
+                    dir_entry, (dir_entry / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE),
+                    length, lfn_entry);
+#endif
+            /*
+             * Time to write the short file name entry.
+             */
+            if (lfn_entry == (lfn_entries + 1))
+            {
+                /* get current cluster number */
+                int rc = fat_file_ioctl(mt_entry, fat_fd, F_CLU_NUM,
+                                        empty_space_offset * bts2rd,
+                                        &dir_pos->sname.cln);
+                if (rc != RC_OK)
+                  return rc;
+
+                dir_pos->sname.ofs = dir_entry;
+
+                if (lfn_start.cln != FAT_FILE_SHORT_NAME)
+                {
+                  rc = fat_file_ioctl(mt_entry, fat_fd, F_CLU_NUM,
+                                      lfn_start.cln * bts2rd,
+                                      &lfn_start.cln);
+                  if (rc != RC_OK)
+                    return rc;
+                }
+                
+                dir_pos->lname.cln = lfn_start.cln;
+                dir_pos->lname.ofs = lfn_start.ofs;
+
+                /* write new node entry */
+                memcpy (entry, (uint8_t *) name_dir_entry,
+                        MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
+                break;
+            }
+
+            /*
+             * This is a long file name and we need to write
+             * a long file name entry. See if this is the
+             * first entry written and if so remember the
+             * the location of the long file name.
+             */
+            if (lfn_start.cln == FAT_FILE_SHORT_NAME)
+            {
+              lfn_start.cln = empty_space_offset;
+              lfn_start.ofs = dir_entry;
+            }
+            
+            /*
+             * Clear the entry before loading the data.
+             */
+            memset (entry, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
+
+            *MSDOS_DIR_LFN_CHECKSUM(entry) = lfn_checksum;
+            
+            p = entry + 1;
+            n = name + (lfn_entries - lfn_entry) * MSDOS_LFN_LEN_PER_ENTRY;
+            
+            for (i = 0; i < MSDOS_LFN_LEN_PER_ENTRY; i++)
+            {
+                *p = *n;
+                if (*n != 0)
+                    n++;
+                
+                switch (i)
+                {
+                    case 4:
+                        p += 5;
+                        break;
+                    case 10:
+                        p += 4;
+                        break;
+                    default:
+                        p += 2;
+                        break;
+                }
+            }
+
+            *MSDOS_DIR_ENTRY_TYPE(entry) = (lfn_entries - lfn_entry) + 1;
+            if (lfn_entry == 1)
+                *MSDOS_DIR_ENTRY_TYPE(entry) |= MSDOS_LAST_LONG_ENTRY;
+            *MSDOS_DIR_ATTR(entry) |= MSDOS_ATTR_LFN;
+        }
+
+        ret = fat_file_write(mt_entry, fat_fd,
+                             (empty_space_offset * bts2rd) + empty_space_entry,
+                             length, fs_info->cl_buf + empty_space_entry);
+        if (ret != length)
+            rtems_set_errno_and_return_minus_one(EIO);
+
+        empty_space_offset++;
+        empty_space_entry = 0;
+        read_cluster = true;
+    }
+    
+    return 0;
 }
 
 /* msdos_find_node_by_cluster_num_in_fat_file --
  *     Find node with specified number of cluster in fat-file.
  *
+ * Note, not updated in the LFN change because it is only used
+ *       for . and .. entries and these are always short.
+ *
  * PARAMETERS:
  *     mt_entry  - mount table entry
  *     fat_fd    - fat-file descriptor
@@ -885,7 +1620,7 @@ int msdos_find_node_by_cluster_num_in_fa
     rtems_filesystem_mount_table_entry_t *mt_entry,
     fat_file_fd_t                        *fat_fd,
     uint32_t                              cl4find,
-    fat_auxiliary_t                      *paux,
+    fat_dir_pos_t                        *dir_pos,
     char                                 *dir_entry
     )
 {
@@ -911,28 +1646,32 @@ int msdos_find_node_by_cluster_num_in_fa
 
         for (i = 0; i < bts2rd; i += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
         {
+            char* entry = (char*) fs_info->cl_buf + i;
+            
             /* if this and all rest entries are empty - return not-found */
-            if ((*MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
+            if ((*MSDOS_DIR_ENTRY_TYPE(entry)) ==
                 MSDOS_THIS_DIR_ENTRY_AND_REST_EMPTY)
                 return MSDOS_NAME_NOT_FOUND_ERR;
 
-            /* have to look at the DIR_NAME as "raw" 8-bit data */
             /* if this entry is empty - skip it */
-            if ((*(uint8_t *)MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
+            if ((*MSDOS_DIR_ENTRY_TYPE(entry)) ==
                 MSDOS_THIS_DIR_ENTRY_EMPTY)
                 continue;
 
             /* if get a non-empty entry - compare clusters num */
-            if (MSDOS_EXTRACT_CLUSTER_NUM((fs_info->cl_buf + i)) == cl4find)
+            if (MSDOS_EXTRACT_CLUSTER_NUM(entry) == cl4find)
             {
                 /* on success fill aux structure and copy all 32 bytes */
                 rc = fat_file_ioctl(mt_entry, fat_fd, F_CLU_NUM, j * bts2rd,
-                                    &paux->cln);
+                                    &dir_pos->sname.cln);
                 if (rc != RC_OK)
                     return rc;
 
-                paux->ofs = i;
-                memcpy(dir_entry, fs_info->cl_buf + i,
+                dir_pos->sname.ofs = i;
+                dir_pos->lname.cln = FAT_FILE_SHORT_NAME;
+                dir_pos->lname.ofs = FAT_FILE_SHORT_NAME;
+                
+                memcpy(dir_entry, entry,
                        MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
                 return RC_OK;
             }
Index: cpukit/libfs/src/dosfs/msdos_mknod.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_mknod.c,v
retrieving revision 1.7
diff -p -u -u -r1.7 msdos_mknod.c
--- cpukit/libfs/src/dosfs/msdos_mknod.c	29 Jul 2008 02:21:14 -0000	1.7
+++ cpukit/libfs/src/dosfs/msdos_mknod.c	23 Apr 2009 07:54:40 -0000
@@ -36,7 +36,7 @@
  *     determines type of the node to be created and creates it.
  *
  * PARAMETERS:
- *     token   - non-formatted name of a new node
+ *     name    - file name to create
  *     mode    - node type
  *     dev     - dev
  *     pathloc - parent directory description
@@ -46,7 +46,7 @@
  *
  */
 int msdos_mknod(
-    const char                        *token,
+    const char                        *name,
     mode_t                             mode,
     dev_t                              dev,
     rtems_filesystem_location_info_t  *pathloc
@@ -56,12 +56,7 @@ int msdos_mknod(
     rtems_status_code    sc = RTEMS_SUCCESSFUL;
     msdos_fs_info_t     *fs_info = pathloc->mt_entry->fs_info;
     msdos_token_types_t  type = 0;
-    char                 new_name[ MSDOS_NAME_MAX + 1 ];
-    int                  len;
-
-    /* check spelling and format new node name */
-    msdos_get_token(token, new_name, &len);
-
+    
     /*
      *  Figure out what type of msdos node this is.
      */
@@ -82,7 +77,7 @@ int msdos_mknod(
         rtems_set_errno_and_return_minus_one(EIO);
 
     /* Create an MSDOS node */
-    rc = msdos_creat_node(pathloc, type, new_name, mode, NULL);
+    rc = msdos_creat_node(pathloc, type, name, strlen(name), mode, NULL);
 
     rtems_semaphore_release(fs_info->vol_sema);
     return rc;
Index: cpukit/libfs/src/imfs/deviceio.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/imfs/deviceio.c,v
retrieving revision 1.20
diff -p -u -u -r1.20 deviceio.c
--- cpukit/libfs/src/imfs/deviceio.c	12 Mar 2009 21:13:15 -0000	1.20
+++ cpukit/libfs/src/imfs/deviceio.c	23 Apr 2009 07:54:40 -0000
@@ -206,12 +206,14 @@ int device_ioctl(
 /*
  *  device_lseek
  *
- *  This handler eats all lseek() operations.
+ *  This handler eats all lseek() operations and does not create
+ *  an error. It assumes all devices can handle the seek. The
+ *  writes fail.
  */
 
-off_t device_lseek(
+rtems_off64_t device_lseek(
   rtems_libio_t *iop,
-  off_t          offset,
+  rtems_off64_t  offset,
   int            whence
 )
 {
@@ -232,7 +234,7 @@ off_t device_lseek(
 
 int device_ftruncate(
   rtems_libio_t *iop,
-  off_t          length
+  rtems_off64_t  length
 )
 {
   return 0;
